# STM32F407G-DISC1 Discovery board

## Overview

The STM32F407G-DISC1 Discovery kit is a complete demonstration and development platform for STMicroelectronics Arm® Cortex®-M4 core-based STM32F407VGT6 microcontroller, with 1 Mbyte of flash memory and 192 Kbytes of SRAM.

The full range of hardware features available on the board helps users to enhance their application development by an evaluation of all the peripherals such as  one ST-MEMS digital accelerometer, one digital microphone, one audio DAC with integrated class D speaker driver, LEDs, push-buttons and a USB OTG Micro-AB connector. Specialized add-on boards can be connected by means of the extension header connectors.

ST-LINK/V2-A is integrated into the board, as the embedded in-circuit debugger and programmer for the STM32 MCU and USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1472-discovery-kit-with-stm32f407vg-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32F407 microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32f407vg.html)
- [STM32F407G-DISC1 board](https://www.st.com/en/evaluation-tools/stm32f4discovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1472-discovery-kit-with-stm32f407vg-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32f4discovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb997-f407vgt6-c01_schematic.pdf)
